///////////////////////////////////////////////////////////////////
// Functy
// 3D graph drawing utility
//
// David Llewellyn-Jones
// http://www.flypig.co.uk
//
// Spring 2009
///////////////////////////////////////////////////////////////////

#ifndef FUNCTION_H
#define FUNCTION_H

///////////////////////////////////////////////////////////////////
// Includes

///////////////////////////////////////////////////////////////////
// Defines

///////////////////////////////////////////////////////////////////
// Structures and enumerations

typedef struct _FuncPersist FuncPersist;

typedef enum _FUNCTYPE {
  FUNCTYPE_INVALID = -1,

  FUNCTYPE_CARTESIAN,
  FUNCTYPE_SPHERICAL,

  FUNCTYPE_NUM
} FUNCTYPE;

///////////////////////////////////////////////////////////////////
// Global variables

///////////////////////////////////////////////////////////////////
// Function prototypes

FuncPersist * NewFuncPersist (FUNCTYPE eType, double fAccuracy);
void DeleteFuncPersist (FuncPersist * psFuncData);

FUNCTYPE GetFunctionType (FuncPersist * psFuncData);
void SetFunction (char const * const szFunction, FuncPersist * psFuncData);
void SetFunctionColours (char const * const szRed, char const * const szGreen, char const * const szBlue, char const * const szAlpha, FuncPersist * psFuncData);
char const * GetFunctionString (FuncPersist * psFuncData);
char const * GetRedString (FuncPersist * psFuncData);
char const * GetGreenString (FuncPersist * psFuncData);
char const * GetBlueString (FuncPersist * psFuncData);
char const * GetAlphaString (FuncPersist * psFuncData);
void SetFunctionRange (double fXMin, double fYMin, double fZMin, double fXWidth, double fYWidth, double fZWidth, FuncPersist * psFuncData);
void GetFunctionRange (double * afRange, FuncPersist * psFuncData);
void SetFunctionPosition (double fXMin, double fYMin, double fZMin, FuncPersist * psFuncData);
void SetFunctionAccuracy (double fAccuracy, FuncPersist * psFuncData);
double GetFunctionAccuracy (FuncPersist * psFuncData);
GLfloat * GetVertices (FuncPersist * psFuncData);
GLfloat * GetNormals (FuncPersist * psFuncData);
GLushort * GetIndices (FuncPersist * psFuncData);
GLfloat * GetColours (FuncPersist * psFuncData);
bool GetColour (float * afGraphColour, FuncPersist * psFuncData);
void GetVertexDimensions (int * pnXVertices, int * pnYVertices, FuncPersist * psFuncData);
void PopulateVertices (FuncPersist * psFuncData);
bool GetTimeDependent (FuncPersist * psFuncData);
void SetFunctionTime (double fTime, FuncPersist * psFuncData);

///////////////////////////////////////////////////////////////////
// Function definitions

#endif /* FUNCTION_H */


